unit USB_IR;
interface
uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,  Dialogs, StdCtrls, ExtCtrls,
  Menus, ComCtrls, MMSystem;

type
  TBits = record
          case integer of
            0: (Bits: set of 0..7);
            1: (b: Byte);
          end;

TForm1 = Class(TForm)
  Frame2 : TGroupbox;
  Shape1 : TShape;
  Shape2 : TShape;
  Shape3 : TShape;
  Shape4 : TShape;
  Shape5 : TShape;
  Shape6 : TShape;
  Shape7 : TShape;
  Shape8 : TShape;
    TrackBar1: TTrackBar;
    Timer1: TTimer;
    DeviceLabel: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ListBox1: TListBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
private
{ Private declarations }
  v: TBits;
  richtung: (up, down);
  procedure display;
public
{ Public declarations }
end;

var
  Form1:TForm1;

implementation

uses adCpuUsage;

{$R *.dfm}

//AVR309.DLL
const
  DLLPath='AVR309.dll';
const
  NO_ERROR=0;
  DEVICE_NOT_PRESENT=1;
  NO_DATA_AVAILABLE=2;
  INVALID_BAUDRATE=3;
  OVERRUN_ERROR=4;
  INVALID_DATABITS=5;
  INVALID_PARITY=6;
  INVALID_STOPBITS=7;

function DoSetDataPortDirections(DirectionByteB, DirectionByteC, DirectionByteD:byte; UsedPorts:byte):integer;  stdcall external DLLPath name 'DoSetDataPortDirections';
function DoSetOutDataPorts(DataOutByteB, DataOutByteC, DataOutByteD:byte; UsedPorts:byte):integer;  stdcall external DLLPath name 'DoSetOutDataPorts';

{ TForm1 }

procedure TForm1.display;
var
  v: Tbits;
  i: integer;
begin
  v := Form1.v;

  // Bits tauschen
  if Checkbox2.Checked then begin
    v.bits := [];
    for i := 0 to 7 do
      if i in Form1.v.Bits then v.bits := v.bits + [7-i];
  end;

  // Invertieren
  if Checkbox1.Checked then v.b := not v.b;

  if 0 in v.bits then begin
    shape1.Brush.Color := $0000FF00;    { grn hell }
    shape1.Pen.Color := $0000C000;      { grn hell rahmen }
  end else begin
    shape1.Brush.Color := $0000C000;    { grn dunkel }
    shape1.Pen.Color := $00008000;      { grn dunkel rahmen }
  end;

  if 1 in v.bits then begin
    shape2.Brush.Color := $0000FF00;    { grn hell }
    shape2.Pen.Color := $0000C000;      { grn hell rahmen }
  end else begin
    shape2.Brush.Color := $0000C000;    { grn dunkel }
    shape2.Pen.Color := $00008000;      { grn dunkel rahmen }
  end;

  if 2 in v.bits then begin
    shape3.Brush.Color := $0000FF00;    { grn hell }
    shape3.Pen.Color := $0000C000;      { grn hell rahmen }
  end else begin
    shape3.Brush.Color := $0000C000;    { grn dunkel }
    shape3.Pen.Color := $00008000;      { grn dunkel rahmen }
  end;

  if 3 in v.bits then begin
    shape4.Brush.Color := $0000FFFF;    { gelb hell }
    shape4.Pen.Color := $0000C0C0;      { gelb hell rahmen }
  end else begin
    shape4.Brush.Color := $0000C0C0;    { gelb dunkel }
    shape4.Pen.Color := $00008080;      { gelb dunkel rahmen }
  end;

  if 4 in v.bits then begin
    shape5.Brush.Color := $0000FFFF;    { gelb hell }
    shape5.Pen.Color := $0000C0C0;      { gelb hell rahmen }
  end else begin
    shape5.Brush.Color := $0000C0C0;    { gelb dunkel }
    shape5.Pen.Color := $00008080;      { gelb dunkel rahmen }
  end;

  if 5 in v.bits then begin
    shape6.Brush.Color := $0000FFFF;    { gelb hell }
    shape6.Pen.Color := $0000C0C0;      { gelb hell rahmen }
  end else begin
    shape6.Brush.Color := $0000C0C0;    { gelb dunkel }
    shape6.Pen.Color := $00008080;      { gelb dunkel rahmen }
  end;

  if 6 in v.bits then begin
    shape7.Brush.Color := $000000FF;    { rot hell }
    shape7.Pen.Color := $000040C0;      { rot hell rahmen }
  end else begin
    shape7.Brush.Color := $000040C0;    { rot dunkel }
    shape7.Pen.Color := $00004080;      { rot dunkel rahmen }
  end;

  if 7 in v.bits then begin
    shape8.Brush.Color := $000000FF;    { rot hell }
    shape8.Pen.Color := $000040C0;      { rot hell rahmen }
  end else begin
    shape8.Brush.Color := $000040C0;    { rot dunkel }
    shape8.Pen.Color := $00004080;      { rot dunkel rahmen }
  end;

  if DeviceLabel.Visible
  then
    DoSetDataPortDirections($FF, 0, 0, 1);

  if DoSetOutDataPorts(v.b, 0, 0, 1) = NO_ERROR
  then
    DeviceLabel.Visible := False
  else
    DeviceLabel.Visible := True;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  DoSetDataPortDirections($FF, 0, 0, 1);

  ListBox1.Items.AddObject('AUS', tObject(1000));
  ListBox1.Items.AddObject('binr inc.', tObject(0));
  ListBox1.Items.AddObject('binr dec.', tObject(1));
  ListBox1.Items.AddObject('Lauflicht unten->oben', tObject(2));
  ListBox1.Items.AddObject('Lauflicht oben->unten', tObject(3));
  ListBox1.Items.AddObject('Lauflicht bidirektional', tObject(4));
  ListBox1.Items.AddObject('CPU-Anzeige', tObject(5));
  ListBox1.Items.AddObject('Festplatten-Anzeige', tObject(1000));
  ListBox1.Items.AddObject('Lautstrke-Anzeige', tObject(1000)); // 7 geht nicht so richtig :-(
  Listbox1.ItemIndex := 0;

  TrackBar1Change(Self);
  Display;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if Listbox1.ItemIndex > -1 then
  case Integer(Listbox1.Items.Objects[Listbox1.ItemIndex]) of
    0, 1, 5, 7: begin
         Timer1.Enabled := true;
       end;
    2, 4: begin
         Timer1.Enabled := true;
         v.bits := [0];
         richtung := up;
       end;
    3: begin
         Timer1.Enabled := true;
         v.bits := [7];
       end;
    else
      Timer1.Enabled := false;
    end;
end;


function SoundVolume: Word;
var
  Volume: record right, left: Word; end;
  WaveOutCaps: TWaveOutCaps;
begin
  Result := 0;
  if WaveOutGetDevCaps(WAVE_MAPPER, @WaveOutCaps, SizeOf(WaveOutCaps)) = MMSYSERR_NOERROR then
  if WaveOutCaps.dwSupport and WAVECAPS_VOLUME = WAVECAPS_VOLUME then
  begin
    WaveOutGetVolume(WAVE_MAPPER, @Volume);
    Result := (Volume.right + Volume.left) div 2;
  end;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
  i: Integer;
  d: Double;
begin
  if Listbox1.ItemIndex > -1 then
  case Integer(Listbox1.Items.Objects[Listbox1.ItemIndex]) of
    0: begin
         if v.b = 255 then v.b := 0 else inc(v.b);
       end;
    1: begin
         if v.b = 0 then v.b := 255 else dec(v.b);
       end;
    2: begin
         if v.bits = [7] then v.bits := [0] else v.b := v.b shl 1;
       end;
    3: begin
         if v.bits = [0] then v.bits := [7] else v.b := v.b shr 1;
       end;
    4: begin
         case richtung of
           up: if v.bits = [7] then richtung := down else v.b := v.b shl 1;
           down: if v.bits = [0] then richtung := up else v.b := v.b shr 1;
         end;
       end;
    5: begin
         CollectCPUData;
         d := GetCPUUsage(0);
         i := trunc(d*8);
         v.b := (2 shl i) - 1;
       end;
    7: begin
         i := trunc(SoundVolume / $10000 * 8 );
         v.b := (2 shl i) - 1;
       end;
  end;
  display;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Timer1.Interval := 1000 div Trackbar1.Position;
end;

end.
